
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <Can_lib.h>

#define STDDEV "can1"

#define FAST_1XMIT 1
#define MESSG_BLOCK 8 
#define USE_RTR 1

main(int argc,char **argv) {
int fd;
int i,sent;
canmsg_t tx[100];
char device[40];

    if(argc == 2) {
	sprintf(device, "/dev/%s", argv[1]);
    }
    else {
	sprintf(device, "/dev/%s", STDDEV);
    }
    printf("using CAN device %s\n", device);
    
    if(( fd = open(device, O_RDWR )) < 0 ) {
	fprintf(stderr,"Error opening CAN device %s\n", device);
        exit(1);
    }

    while(1){
      for(i=0;i<MESSG_BLOCK;i++) {
        tx[i].flags=0;
	tx[i].id=1+(int)( 500.0*rand()/RAND_MAX+1.0 );
	sprintf( tx[i].data,"%dabcde",tx[i].id );
	printf("send: '%s' \n",tx[i].data);
	tx[i].length = strlen(tx[i].data); 

#if USE_RTR 
        if(tx[i].id == 500 ||tx[i].id == 400 ||tx[i].id == 300 || tx[i].id == 200 || tx[i].id == 100 )
	  tx[i].flags |= MSG_RTR;
#endif

#if !FAST_1XMIT
       sent=write(fd, &tx[i], 1 ); sleep(1);
      if(sent <= 0) {
	printf("not ready"); break;
      }	   
	 
#endif
      }
#if FAST_1XMIT
       sent=write(fd, tx, MESSG_BLOCK ); sleep(1); 
      if(sent <= 0) {
	printf("not ready"); break;
      }
#endif
    }

close(fd);


}
