#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <Can_lib.h>

#define STDDEV "can0"

main(int argc,char **argv) {
int fd;
int id;
int i,got;
canmsg_t rx[80];
canmsg_t rtrr;
char device[40];
fd_set rfds;


    if(argc >= 2) {
	sprintf(device, "/dev/%s", argv[1]);
    }
    else {
	sprintf(device, "/dev/%s", STDDEV);
    }
    printf("using CAN device %s\n", device);

if(( fd = open(device, O_RDWR )) < 0 ) {
  fprintf(stderr,"Error opening CAN device %s\n", device);
  exit(1);
}

if( argc >= 3 ) {
  for(i = 2;i<argc;i++) {
    id = atoi(argv[i]);
    printf("setting rtr on id %d\n",id);

    rtrr.id = id;
    sprintf(rtrr.data,"RTR%d",id);
    rtrr.length = strlen(rtrr.data);

    can_ConfigureRTR(fd, id, &rtrr );
  }
}

printf("waiting for msg at 0x%lx:\n",&rx);

while(1) {
  FD_ZERO(&rfds);
  FD_SET(fd,&rfds);
  if( select(FD_SETSIZE, &rfds, NULL, NULL, NULL  ) > 0 && FD_ISSET(fd,&rfds) ) {

  got=read(fd, rx , 79 );
  if( got > 0) {
    for(i=0;i<got;i++) {
      printf("Received got=%d: id=%d len=%d msg='%s' \n",
      		got, rx[i].id, rx[i].length, rx[i].data );
      fflush(stdout); }
  } else {
      printf("- Received got=%d: id=%d len=%d msg='%s' \n",
      		got, rx[i].id, rx[i].length, rx[i].data );
      fflush(stdout); }
  /*sleep(1);*/
  }
}


close(fd);


}
