#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>



#include <Can_P.h>



int can_init(int port) {
  char dev[10];
  sprintf(dev,"/dev/can%d",port);
    
  return open(dev,O_RDWR);
}

int can_close(int fd) {
  return close(fd);
}

int can_send(int fd, int len,char *message) {
 char *token;
 canmsg_t tx;
 int j,sent=0;
 
 if(( token = strtok(message,":") ) != NULL ) {
   tx.flags=0;
   if( token[0] == 'r' || token[0] == 'R' ) {
     tx.flags = MSG_RTR;
     tx.id = strtol(&token[1],NULL,0);
     tx.length=len;
   } else {
     tx.id = strtol(token,NULL,0);
     j=0;
     while( (token = strtok(NULL,",")) != NULL ) {
       /*printf("'%c' ",strtol(token,NULL,0) );*/
       tx.data[j++] = strtol(token,NULL,0);
     }
     tx.length=(len>0 ? len : j );
   }
   sent = write(fd,&tx,1);
   /*if(sent > 0 ) printf(" OK\n"); fflush(stdout);*/
   
   return 1;
 } else {

   return -1;
 }

}


int can_filter(int fd,char *fstring) {
  char *token;
  int i;

  if(( token = strtok(fstring,",")) != NULL ) {
    if( token[0] == '*' ) {
      can_Config(fd, CONF_FILTER, 0 );
printf("\nfilter disabled");
    } else {
      can_Config(fd, CONF_FILTER, 1 );
      can_Config(fd, CONF_FENABLE, strtol(token,NULL,0));
printf("\naccept %d",strtol(token,NULL,0));
    }
    while((token=strtok(NULL,",")) != NULL ) {
      can_Config(fd, CONF_FENABLE, strtol(token,NULL,0));
printf("\naccept %d",strtol(token,NULL,0));
    }
    return 1;
  }
  return -1;
  
}




char *can_read(int fd, int timeout) {
fd_set   rfds;
struct   timeval tv;
int      got,i,j;
canmsg_t rx[80];
char     databuf[4096];
char     *s;

  FD_ZERO(&rfds);
  FD_SET(fd,&rfds);

  tv.tv_sec  = 0; /* wait 5 seconds before process terminates */
  tv.tv_usec = timeout;
  s = &databuf[0];
  s += sprintf(s,"",fd);
  got=0;
  if( select(FD_SETSIZE, &rfds, NULL, NULL, ( timeout > 0 ? &tv : NULL )  ) > 0 && FD_ISSET(fd,&rfds) ) {

      got = read(fd, rx , 79 );
      /*s += sprintf(s, "got=%d",got);*/
      if( got > 0) {

	/*s += sprintf(s, "\n");*/

	for(i=0;i<got;i++) {
	  rx[i].data[rx[i].length] = 0;
	  if( rx[i].flags & MSG_RTR ) {
	    s += sprintf(s, "0x%04x R %c",rx[i].id,(rx[i].flags & MSG_OVR ? 'O' : '.' )) ;
          }
	  else {
	    s += sprintf(s, "0x%04x . %c %d ",rx[i].id,(rx[i].flags & MSG_OVR ? 'O' : '.' ) ,rx[i].length );      
	    for(j=0;j<rx[i].length;j++)
	      s += sprintf(s, " 0x%02x",rx[i].data[j] ); 
	    for(;j<8;j++)
	      s += sprintf(s, "  .  "); 
	    s+=sprintf(s," '%s'",rx[i].data);
          }
	  s += sprintf(s, "\n");

	} 
      }
  }

return databuf;
}


typedef  union {
    int   i;
    float f;
    char  byte[4];
  } xVal;


char *f2byte ( float f ) {
  xVal val;
  char buf[80];
  val.f = f;
  sprintf(buf,"0x%x,0x%x,0x%x,0x%x",(val.byte[0] & 0xff),val.byte[1] & 0xff,val.byte[2] & 0xff ,val.byte[3] & 0xff );

  return buf;
}

float byte2f (char *bytes) {
  xVal val;
  char *token;
  if(( token = strtok( bytes, " ")) != NULL ) {
    val.byte[0] = strtol(token, NULL,0);
    if(( token = strtok( NULL," " )) != NULL ) 
      val.byte[1] = strtol(token, NULL,0);
    if(( token = strtok( NULL," " )) != NULL ) 
      val.byte[2] = strtol(token, NULL,0);
    if(( token = strtok( NULL," " )) != NULL ) 
      val.byte[3] = strtol(token, NULL,0);
  }
#if 0
  printf("byte2f=0x%x,0x%x,0x%x,0x%x",
  (val.byte[0] & 0xff),val.byte[1] & 0xff,val.byte[2] & 0xff ,val.byte[3] & 0xff );
#endif
  return val.f;
}

char *int2byte ( int i ) {
  xVal val;
  char buf[80];
  val.i = i;
  sprintf(buf,"0x%x,0x%x,0x%x,0x%x",(val.byte[0] & 0xff),val.byte[1] & 0xff,val.byte[2] & 0xff ,val.byte[3] & 0xff );

  return buf;
}

int byte2int (char *bytes) {
  xVal val;
  char *token;
  if(( token = strtok( bytes, " ")) != NULL ) {
    val.byte[0] = strtol(token, NULL,0);
    if(( token = strtok( NULL," " )) != NULL ) 
      val.byte[1] = strtol(token, NULL,0);
    if(( token = strtok( NULL," " )) != NULL ) 
      val.byte[2] = strtol(token, NULL,0);
    if(( token = strtok( NULL," " )) != NULL ) 
      val.byte[3] = strtol(token, NULL,0);
  }
#if 0
  printf("byte2f=0x%x,0x%x,0x%x,0x%x",
      (val.byte[0] & 0xff),val.byte[1] & 0xff,val.byte[2] & 0xff ,val.byte[3] & 0xff );
#endif
  return val.i;
}







