%module Cansupport
%{ 
#include <Can_P.h>

%}

extern int can_init (int port);
/* Initializes the CAN subsystem and opens the port given in the argument,
port can be one of [0-3] */

extern int can_close(int port);
/* Closes the CAN subsystem */

extern int can_send (int fd, int len,char *message);
/* Sends a message in compact message format 
   id:data0[,data1[....,dataN]]
*/

extern char *can_read(int fd, int timeout);
/* Reads out the Rx-Fifo */

extern int can_filter(int fd,char *fstring);
/* sets the filter to enable certain identifiers */

extern char *f2byte(float f);
/* converts a float value in a 4 byte message */

extern float byte2f (char *bytes);
/* converts a 4 byte message in a float value */

extern int byte2int(char *bytes);
/* converts a 4 byte message into an integer */

extern char *int2byte(int i);
/* converts an integer to a 4 byte message */
